rem utilitaire de formattage de carte compact-flash/sd pour windows.
rem par LaBibleATARI www.labibleatari.fr
rem 07/02/2016
rem v1.0
rem droit de copie et de modification libre.

cls
@echo off
color 1E
title PREPARATEUR DE DISQUE IDE POUR ATARI ST (TALREK-LABIBLEATARI 2016)

mode con lines=25 cols=80
setlocal ENABLEDELAYEDEXPANSION

set path=%path%;

if "%PROCESSOR_ARCHITECTURE%"=="x86" set devcon=".\drivers\devcon.exe"
if "%PROCESSOR_ARCHITECTURE%"=="AMD64" set devcon=".\drivers\devcon64.exe"

:: TEST DE LA VERSION DE WINDOWS

VER|find "Windows XP">NUL 
VER|find "version 5">NUL
IF NOT ERRORLEVEL 1 (
goto WINDOWSXP
)
goto SUPERIEURXP

:WINDOWSXP
set typeos=xp
goto init
:SUPERIEURXP
set typeos=supxp
REM CHANGEZ ICI LA TAILLE EN Mo DES PARTITIONS DE BOOT ET LES PARTITIONS ETENDUES

:init
set partboot=121 
set partssec=1000
set nbrparts=13

:Menu
cls
echo ͻ
echo                     PARTITIONNEUR ET FORMATEUR DE DISQUE IDE                 
echo                        ET DISQUETTE PAR LABIBLEATARI V1.0                    
echo                                                                              
echo                                                                              
echo        1. FORMATER UNE DISQUETTE 720Ko                                       
echo                                                                              
echo        2. FORMATER UNE DISQUETTE 1,44Mo                                      
echo                                                                              
echo        3. FORMATER ET PARTITIONNER UN DISQUE DUR IDE                         
echo                                                                              
echo        4. FORMATER ET PARTITIONNER UN SUPPORT AMOVIBLE (COMPACT-FLASH)       
echo                                                                              
echo        5. CHOISIR LA TAILLE PAR DEFAUT DES PARTITIONS ET LEUR NOMBRE         
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                    IMPORTANT :                               
echo     ASSUREZ VOUS DE N AVOIR BRANCHE QUE LE DISQUE DUR OU CF/SD SUR LE PC     
echo        DEBRANCHEZ SI BESOIN DISQUE DUR USB OU CLEF USB DE L ORDINATEUR       
echo                                                                              
echo ͼ
set /p choix= Faite votre choix puis tapez entree 
if %choix%==1 goto format720
if %choix%==2 goto format144
if %choix%==3 goto diskpart
if %choix%==4 goto cfpart
if %choix%==5 goto partsmodif

:format720
echo o>%tmp%\o.txt
format a: /t:80 /n:9 /v: <%tmp%\o.txt
cls
goto menu
:format144
echo o>%tmp%\o.txt
format a: /t:80 /n:18 /v: <%tmp%\o.txt
cls
goto menu

:diskpart

cls
echo list disk | diskpart
set nodisk=1
set /p nodisk= A quel numro correspond votre disque  formater (1 par defaut) ? 

cls


:: generation du script de formattage pour diskpart.

 > "%tmp%\diskpart.txt" (
echo SELECT DISK %nodisk%
echo CLEAN
echo CREATE PART PRI size=%partboot% 
echo ACTIVE
echo assign
)

if %typeos%==supxp (echo format fs=fat label="P1" quick>>"%tmp%\diskpart.txt")
echo create partition extended>>"%tmp%\diskpart.txt"
for /L %%i in (1,1,%nbrparts%) do (echo create partition logical size=%partssec%>>"%tmp%\diskpart.txt" & echo assign>>"%tmp%\diskpart.txt" & if %typeos%==supxp echo FORMAT fs=fat label="Pe%%i" QUICK >>"%tmp%\diskpart.txt")

:: execution de diskpart
diskpart /s "%tmp%\diskpart.txt"


:: definition de la premiere partition non formate
if %typeos%==supxp (
FOR %%A IN (D E F G H I J K L M N O P Q R S T) DO IF EXIST %%A: (FOR /F "TOKENS=*" %%B IN ('chkdsk %%A:^|FIND /I "P1"') DO (set partnf=%%A & goto copybigdos))
)

:defpartxp
:: definition de la premiere partition non formate
FOR %%A IN (D E F G H I J K L M N O P Q R S T) DO IF NOT EXIST %%A: (FOR /F "TOKENS=*" %%B IN ('chkdsk %%A:^|FIND /I "raw"') DO (set partnf=%%A & goto partformat))

:partformat
cls
echo ͻ
echo                    PARTITIONNEUR ET FORMATEUR DE DISQUE IDE                  
echo                         ET DISQUETTE PAR LABIBLEATARI                        
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo           LE PROGRAMME VA MAINTENANT FORMATER LES PARTITIONS CREES           
echo                                SUR VOTRE SUPPORT                             
echo                                                                              
echo         MERCI DE SAISIR LA LETTRE DE LA PREMIERE PARTITION DE 128 Mo         
echo          SI ELLE NE CORRESPOND PAS A CELLE TROUVEE PAR LE PROGRAMME          
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo ͼ
set /p partnf= Lettre de la premiere partition ? (%partnf%: trouvee par defaut) 

echo %partnf%

:: Si Windows xp ne formate pas avec dikpart.On utilise format
:: Formatage de la partition de boot
echo o>%tmp%\o.txt
if %typeos%==xp (format %partnf: =%: /fs:fat /a:2048 /v:P1 <%tmp%\o.txt)

:: Formatage des partitions etendues
if %typeos%==xp (
FOR %%A IN (D E F G H I J K L M N O P Q R S T) DO IF NOT EXIST %%A: (FOR /F "TOKENS=*" %%B IN ('chkdsk %%A:^|FIND /I "raw"') DO (format %%A: /fs:fat /v:Pe%%A<%tmp%\o.txt))
)

::On cherche la lettre de la premiere partition du disque d'apres le nom P1
FOR %%A IN (D E F G H I J K L M N O P) DO IF EXIST %%A: (FOR /F "TOKENS=*" %%B IN ('VOL %%A:^|FIND /I "P1"') DO (set part1=%%A))

:copybigdos

::Copy de BIGDOS.PRG sur la partition de boot du disque
if exist ".\drivers\BIGDOS.PRG" (md "%partnf: =%:\auto" & copy ".\drivers\BIGDOS.PRG" "%partnf: =%:\auto" & goto succee) else (cls & echo il faut copier bigdos.prg dans le dossier auto de la premiere partition du disque)

:succee
cls
echo ͻ
echo                    PARTITIONNEUR ET FORMATEUR DE DISQUE IDE                  
echo                         ET DISQUETTE PAR LABIBLEATARI                        
echo                                                                              
echo                                                                              
echo               LE DISQUE EST PRET A ETRE UTILISE SUR VOTRE ATARI              
echo                                                                              
echo   Sur un atari ST avec un TOS ^< 2.06 il vous faut installer le pilote IDE    
echo   IDEDx.PRG de PPERA dans le dossier auto d'une disquette pour avoir access  
echo   aux partitions du disque.                                                  
echo   Sur Mega STE ou tout ST equipe du tos 2.06, lancer le programme PPP13U.PRG 
echo   pour rendre bootable le disque dur.                                        
echo   Rebootez votre ST et profitez de votre disque dur.                         
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo   Remerciements a PPera, TalRek et aux passionnes. LaBibleATARI              
echo                                                                              
echo ͼ

PAUSE

goto menu

:partsmodif

cls
echo ͻ
echo                    PARTITIONNEUR ET FORMATEUR DE DISQUE IDE                  
echo                         ET DISQUETTE PAR LABIBLEATARI                        
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                 SAISISSEZ LA TAILLE DE VOTRE PARTITION DE BOOT               
echo                                                                              
echo                              (128Mo TAILLE MAX)                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo ͼ
set /p partboot= Taille de la premiere partition ? (128Mo par defaut) 

:partsmodif2

cls
echo ͻ
echo                    PARTITIONNEUR ET FORMATEUR DE DISQUE IDE                  
echo                         ET DISQUETTE PAR LABIBLEATARI                        
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                 SAISISSEZ LA TAILLE DE VOS PARTITION ETENDUES                
echo                                                                              
echo                           (2000Mo (2Go) TAILLE MAX)                          
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo ͼ
set /p partssec= Taille de la premiere partition ? (999Mo par defaut) 

cls
echo ͻ
echo                    PARTITIONNEUR ET FORMATEUR DE DISQUE IDE                  
echo                         ET DISQUETTE PAR LABIBLEATARI                        
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                  SAISISSEZ LE NOMBRE DE PARTITIONS ETENDUES                  
echo                                                                              
echo               (13 MAX ET 14 AU TOTAL AVEC LA PARTITION DE BOOT)              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo ͼ
set /p nbrparts= Nombre de partitions etendues ? (13 par defaut) 

goto menu
 
:cfpart

:: Recherche de l'ID du disque Compact-Flash/SD amovible.
for /f "usebackq" %%A in (`wmic path  Win32_DiskDrive Where "MediaType LIKE '%%Removable%%'" Get PNPDeviceID^| FIND "USB"`) do set driveid=%%A && goto driveok

:drivenotok
cls
echo ͻ
echo                    PARTITIONNEUR ET FORMATEUR DE DISQUE IDE                  
echo                         ET DISQUETTE PAR LABIBLEATARI                        
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                         SUPPORT AMOVIBLE NON DETECTE                         
echo                                                                              
echo        VERIFIEZ QUE VOTRE CARTE COMPACT FLASH OU SD SOIT BIEN BRANCHEE       
echo                                                                              
echo       SI LE SUPPORT EST BIEN BRANCHE IL PEUT S AGIR D UNE COMPACT-FLASH      
echo                                                                              
echo                         RECONNUE COMME UN DISQUE FIXE.                       
echo                                                                              
echo       DANS CE CAS ELLE PEUT ETRE FORMATE DIRECTEMENT. REBRANCHEZ LA CF       
echo              PUIS TAPEZ ENTREE POUR FAIRE UNE NOUVELLE DETECTION.            
echo                                                                              
echo                                                                              
echo                   FAITES UN CHOIX CI-DESSOUS POUR CONTINUER :                
echo                                                                              
echo                                                                              
echo ͼ
set /p choix= Redetection : "Entree", "M" pour retour au menu 
if %choix%==m goto menu goto cfpart

:driveok
for /f "usebackq" %%B in (`wmic path  Win32_DiskDrive Where "MediaType LIKE '%%Removable%%'" Get Model^| FIND "USB"`) do set modeldrive=%%B
set choix=o
cls
echo ͻ
echo                    PARTITIONNEUR ET FORMATEUR DE DISQUE IDE                  
echo                         ET DISQUETTE PAR LABIBLEATARI                        
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                           SUPPORT AMOVIBLE DETECTE                           
echo                                                                              
echo                 LE PROGRAMME VA PARAMETRER LE DRIVER POUR QUE                
echo                                                                              
echo         POUR QUE LE SUPPORT PUISSE ETRE FORMATE COMME UN DISQUE DUR          
echo                                                                              
echo              UNE FENETRE D INSTALLATION DE DRIVER VA APPARAITRE              
echo                                                                              
echo              CLIQUER SUR CONTINUER POUR FINALISER L INSTALLATION             
echo                                                                              
echo              LE PROGRAMME CONTINUERA POUR LE FORMATAGE DU DISQUE             
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo ͼ
set /p choix= Le disque amovible trouve est : %modeldrive%; On continue ? (O/n) 
if %choix%==n menu else goto createdriver

cls
:: creation du driver pour le disque detecte.
:: createdriver

 > ".\drivers\cfadisk.inf" (
echo [Version]
echo Signature="$Windows NT$"
echo Class=DiskDrive
echo ClassGuid={4D36E967-E325-11CE-BFC1-08002BE10318}
echo Provider=%%HGST%%
echo LayoutFile=layout.inf
echo DriverVer=12/14/2002,1.00.0000.1
echo. 
echo [Manufacturer]
echo %%HGST%% = cfadisk_device
echo. 
echo [DestinationDirs]
echo cfadisk_copyfiles=12    ; %%SystemRoot%%\system32\drivers
echo gendisk_copyfiles=12    ; %%SystemRoot%%\system32\drivers
echo. 
echo [cfadisk_copyfiles]
echo cfadisk.sys
echo. 
echo [gendisk_copyfiles]
echo disk.sys
echo. 
echo ; ---------------------
echo. 
echo [cfadisk_device]
echo %%Microdrive_devdesc%% = cfadisk_install,USBSTOR\GenDisk
echo. 
echo ; Atari special device.
echo %%Microdrive_devdesc%% = cfadisk_install,IDE\%driveid:&=^&%
::echo Microdrive_devdesc = "Disque IDE ATARI ST"
echo.
echo [cfadisk_addreg]
echo HKR,,"LowerFilters",0x00010008,"cfadisk"
echo. 
echo [cfadisk_install]
echo CopyFiles=cfadisk_copyfiles,gendisk_copyfiles
echo. 
echo [cfadisk_install.HW]
echo AddReg=cfadisk_addreg
echo. 
echo [cfadisk_install.Services]
echo AddService=disk,2,gendisk_ServiceInstallSection
echo AddService=cfadisk,,cfadisk_ServiceInstallSection
echo. 
echo [gendisk_ServiceInstallSection]
echo DisplayName    = "Disk Driver"
echo ServiceType    = 1
echo StartType      = 0
echo ErrorControl   = 1
echo ServiceBinary  = %%12%%\disk.sys
echo LoadOrderGroup = SCSI Class
echo. 
echo [cfadisk_ServiceInstallSection]
echo DisplayName    = "CompactFlash Filter Driver"
echo ServiceType    = 1
echo StartType      = 3
echo ErrorControl   = 1
echo ServiceBinary  = %%12%%\cfadisk.sys
echo LoadOrderGroup = Pnp Filter
echo. 
echo ; -----------------------
echo. 
echo [Strings]
echo HGST = "Hitachi Global Storage Technologies"
echo Microdrive_devdesc = "ATARI ST Microdrive"
)
rem desactivation de la signature numrique pour installation du driver sans msg
REG ADD "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Driver Signing" /v Policy /t REG_BINARY /f /d 00

:: installation du driver
cls
echo Support amovible en cours d'installation en unite fixe
echo.
%devcon% update ".\drivers\cfadisk.inf" "USBSTOR\DISK"

ping -n 10 localhost >nul

:: creation du scritp de desinstallation du driver de preparation atari
:: > ".\removecf.cmd" (
::echo devcon update "%driveid:&=^&%"
::echo devcon rescan
::) 

rem reactivation de la signature numrique suite  reparametrage et reinstallation du pilote
REG ADD "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Driver Signing" /v Policy /t REG_BINARY /f /d 01


:: preparation du support finie on va au formatage

goto diskpart

pause
